diff --git a/libpurple/purplechatconversation.c b/libpurple/purplechatconversation.c
--- a/libpurple/purplechatconversation.c
+++ b/libpurple/purplechatconversation.c
@@ -1035,7 +1035,7 @@ purple_chat_conversation_get_nick(Purple
 }
 
 static void
-invite_user_to_chat(gpointer data, PurpleRequestFields *fields) {
+invite_user_to_chat(gpointer data, PurpleRequestPage *page) {
 	PurpleChatConversation *chat;
 	PurpleChatConversationPrivate *priv;
 	PurpleConnection *pc;
@@ -1044,8 +1044,8 @@ invite_user_to_chat(gpointer data, Purpl
 	chat = PURPLE_CHAT_CONVERSATION(data);
 	priv = purple_chat_conversation_get_instance_private(chat);
 
-	user = purple_request_fields_get_string(fields, "screenname");
-	message = purple_request_fields_get_string(fields, "message");
+	user = purple_request_page_get_string(page, "screenname");
+	message = purple_request_page_get_string(page, "message");
 
 	pc = purple_conversation_get_connection(PURPLE_CONVERSATION(chat));
 	purple_serv_chat_invite(pc, priv->id, message, user);
@@ -1057,7 +1057,7 @@ purple_chat_conversation_invite_user(Pur
                                      gboolean confirm)
 {
 	PurpleAccount *account;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
@@ -1076,9 +1076,9 @@ purple_chat_conversation_invite_user(Pur
 		return;
 	}
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(_("Invite to chat"));
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("screenname", _("Buddy"), user,
 	                                        FALSE);
@@ -1093,7 +1093,7 @@ purple_chat_conversation_invite_user(Pur
 	purple_request_fields(chat, _("Invite to chat"), NULL,
 	                      _("Please enter the name of the user you wish to "
 	                        "invite, along with an optional invite message."),
-	                      fields,
+	                      page,
 	                      _("Invite"), G_CALLBACK(invite_user_to_chat),
 	                      _("Cancel"), NULL,
 	                      purple_request_cpar_from_conversation(PURPLE_CONVERSATION(chat)),
diff --git a/libpurple/purpleprivate.h b/libpurple/purpleprivate.h
--- a/libpurple/purpleprivate.h
+++ b/libpurple/purpleprivate.h
@@ -338,10 +338,10 @@ void purple_whiteboard_manager_shutdown(
  */
 G_GNUC_INTERNAL void purple_account_set_enabled_plain(PurpleAccount *account, gboolean enabled);
 
-G_GNUC_INTERNAL void _purple_request_field_list_add_field(PurpleRequestFields *fields, PurpleRequestField *field);
-G_GNUC_INTERNAL void _purple_request_field_list_set_field_required(PurpleRequestFields *fields, PurpleRequestField *field, gboolean required);
-G_GNUC_INTERNAL void _purple_request_field_list_set_field_validator(PurpleRequestFields *fields, PurpleRequestField *field, gboolean validator);
-G_GNUC_INTERNAL void _purple_request_group_set_field_list(PurpleRequestGroup *group, PurpleRequestFields *fields);
+G_GNUC_INTERNAL void _purple_request_page_add_field(PurpleRequestPage *fields, PurpleRequestField *field);
+G_GNUC_INTERNAL void _purple_request_page_set_field_required(PurpleRequestPage *fields, PurpleRequestField *field, gboolean required);
+G_GNUC_INTERNAL void _purple_request_page_set_field_validator(PurpleRequestPage *fields, PurpleRequestField *field, gboolean validator);
+G_GNUC_INTERNAL void _purple_request_group_set_page(PurpleRequestGroup *group, PurpleRequestPage *fields);
 G_GNUC_INTERNAL void _purple_request_group_set_field_required(PurpleRequestGroup *group, PurpleRequestField *field, gboolean required);
 G_GNUC_INTERNAL void _purple_request_group_set_field_validator(PurpleRequestGroup *group, PurpleRequestField *field, gboolean validator);
 G_GNUC_INTERNAL void _purple_request_field_set_group(PurpleRequestField *field, PurpleRequestGroup *group);
diff --git a/libpurple/purplerequestgroup.h b/libpurple/purplerequestgroup.h
--- a/libpurple/purplerequestgroup.h
+++ b/libpurple/purplerequestgroup.h
@@ -87,14 +87,14 @@ const char *purple_request_group_get_tit
 GList *purple_request_group_get_fields(PurpleRequestGroup *group);
 
 /**
- * purple_request_group_get_fields_list:
+ * purple_request_group_get_page:
  * @group: The group.
  *
  * Returns a list of all fields in a group.
  *
  * Returns: (transfer none): The list of fields in the group.
  */
-PurpleRequestFields *purple_request_group_get_fields_list(PurpleRequestGroup *group);
+PurpleRequestPage *purple_request_group_get_page(PurpleRequestGroup *group);
 
 G_END_DECLS
 
diff --git a/libpurple/purplerequestgroup.c b/libpurple/purplerequestgroup.c
--- a/libpurple/purplerequestgroup.c
+++ b/libpurple/purplerequestgroup.c
@@ -28,7 +28,7 @@
 struct _PurpleRequestGroup {
 	GObject parent;
 
-	PurpleRequestFields *fields_list;
+	PurpleRequestPage *page;
 
 	char *title;
 
@@ -171,12 +171,12 @@ purple_request_group_new(const char *tit
 }
 
 void
-_purple_request_group_set_field_list(PurpleRequestGroup *group,
-                                     PurpleRequestFields *fields)
+_purple_request_group_set_page(PurpleRequestGroup *group,
+                               PurpleRequestPage *page)
 {
 	g_return_if_fail(PURPLE_IS_REQUEST_GROUP(group));
 
-	group->fields_list = fields;
+	group->page = page;
 }
 
 void
@@ -186,8 +186,7 @@ void
 {
 	g_return_if_fail(PURPLE_IS_REQUEST_GROUP(group));
 
-	_purple_request_field_list_set_field_required(group->fields_list, field,
-	                                              required);
+	_purple_request_page_set_field_required(group->page, field, required);
 }
 
 void
@@ -197,8 +196,7 @@ void
 {
 	g_return_if_fail(PURPLE_IS_REQUEST_GROUP(group));
 
-	_purple_request_field_list_set_field_validator(group->fields_list, field,
-	                                               validator);
+	_purple_request_page_set_field_validator(group->page, field, validator);
 }
 
 void
@@ -213,8 +211,8 @@ purple_request_group_add_field(PurpleReq
 	position = g_list_length(group->fields);
 	group->fields = g_list_append(group->fields, field);
 
-	if(group->fields_list != NULL) {
-		_purple_request_field_list_add_field(group->fields_list, field);
+	if(PURPLE_IS_REQUEST_PAGE(group->page)) {
+		_purple_request_page_add_field(group->page, field);
 	}
 
 	_purple_request_field_set_group(field, group);
@@ -238,10 +236,10 @@ purple_request_group_get_fields(PurpleRe
 	return group->fields;
 }
 
-PurpleRequestFields *
-purple_request_group_get_fields_list(PurpleRequestGroup *group)
+PurpleRequestPage *
+purple_request_group_get_page(PurpleRequestGroup *group)
 {
 	g_return_val_if_fail(PURPLE_IS_REQUEST_GROUP(group), NULL);
 
-	return group->fields_list;
+	return group->page;
 }
diff --git a/libpurple/purplerequestpage.h b/libpurple/purplerequestpage.h
--- a/libpurple/purplerequestpage.h
+++ b/libpurple/purplerequestpage.h
@@ -33,11 +33,11 @@
 #include <glib-object.h>
 
 /**
- * PurpleRequestFields:
+ * PurpleRequestPage:
  *
  * Multiple fields request data.
  */
-typedef struct _PurpleRequestFields PurpleRequestFields;
+typedef struct _PurpleRequestPage PurpleRequestPage;
 
 #include "account.h"
 #include "purplerequestgroup.h"
@@ -45,185 +45,169 @@ typedef struct _PurpleRequestFields Purp
 
 G_BEGIN_DECLS
 
-/**
- * purple_request_fields_new:
- *
- * Creates a list of fields to pass to purple_request_fields().
- *
- * Returns: (transfer full): A PurpleRequestFields structure.
- */
-PurpleRequestFields *purple_request_fields_new(void);
+#define PURPLE_TYPE_REQUEST_PAGE (purple_request_page_get_type())
+G_DECLARE_FINAL_TYPE(PurpleRequestPage, purple_request_page,
+                     PURPLE, REQUEST_PAGE, GObject)
 
 /**
- * purple_request_fields_destroy:
- * @fields: The list of fields to destroy.
+ * purple_request_page_new:
+ *
+ * Creates a page of fields to pass to [func@Purple.request_fields].
  *
- * Destroys a list of fields.
+ * Returns: (transfer full): The new request page.
  */
-void purple_request_fields_destroy(PurpleRequestFields *fields);
+PurpleRequestPage *purple_request_page_new(void);
 
 /**
- * purple_request_fields_add_group:
- * @fields: The fields list.
- * @group:  The group to add.
+ * purple_request_page_add_group:
+ * @page: The fields page.
+ * @group: (transfer full): The group to add.
  *
  * Adds a group of fields to the list.
  */
-void purple_request_fields_add_group(PurpleRequestFields *fields, PurpleRequestGroup *group);
+void purple_request_page_add_group(PurpleRequestPage *page, PurpleRequestGroup *group);
 
 /**
- * purple_request_fields_get_groups:
- * @fields: The fields list.
+ * purple_request_page_get_groups:
+ * @page: The fields page.
  *
  * Returns a list of all groups in a field list.
  *
  * Returns: (element-type PurpleRequestGroup) (transfer none): A list of groups.
  */
-GList *purple_request_fields_get_groups(const PurpleRequestFields *fields);
+GList *purple_request_page_get_groups(PurpleRequestPage *page);
 
 /**
- * purple_request_fields_exists:
- * @fields: The fields list.
- * @id:     The ID of the field.
+ * purple_request_page_exists:
+ * @page: The fields page.
+ * @id: The ID of the field.
  *
  * Returns whether or not the field with the specified ID exists.
  *
  * Returns: TRUE if the field exists, or FALSE.
  */
-gboolean purple_request_fields_exists(const PurpleRequestFields *fields,
-									const char *id);
+gboolean purple_request_page_exists(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_required:
- * @fields: The fields list.
+ * purple_request_page_get_required:
+ * @page: The fields page.
  *
  * Returns a list of all required fields.
  *
  * Returns: (element-type PurpleRequestField) (transfer none): The list of required fields.
  */
-const GList *purple_request_fields_get_required(
-	const PurpleRequestFields *fields);
+const GList *purple_request_page_get_required(PurpleRequestPage *page);
 
 /**
- * purple_request_fields_get_validatable:
- * @fields: The fields list.
+ * purple_request_page_get_validatable:
+ * @page: The fields page.
  *
  * Returns a list of all validated fields.
  *
  * Returns: (element-type PurpleRequestField) (transfer none): The list of validated fields.
  */
-const GList *purple_request_fields_get_validatable(
-	const PurpleRequestFields *fields);
+const GList *purple_request_page_get_validatable(PurpleRequestPage *page);
 
 /**
- * purple_request_fields_is_field_required:
- * @fields: The fields list.
- * @id:     The field ID.
+ * purple_request_page_is_field_required:
+ * @page: The fields page.
+ * @id: The field ID.
  *
  * Returns whether or not a field with the specified ID is required.
  *
  * Returns: TRUE if the specified field is required, or FALSE.
  */
-gboolean purple_request_fields_is_field_required(const PurpleRequestFields *fields,
-											   const char *id);
+gboolean purple_request_page_is_field_required(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_all_required_filled:
- * @fields: The fields list.
+ * purple_request_page_all_required_filled:
+ * @page: The fields page.
  *
  * Returns whether or not all required fields have values.
  *
  * Returns: TRUE if all required fields have values, or FALSE.
  */
-gboolean purple_request_fields_all_required_filled(
-	const PurpleRequestFields *fields);
+gboolean purple_request_page_all_required_filled(PurpleRequestPage *page);
 
 /**
- * purple_request_fields_all_valid:
- * @fields: The fields list.
+ * purple_request_page_all_valid:
+ * @page: The fields page.
  *
  * Returns whether or not all fields are valid.
  *
  * Returns: TRUE if all fields are valid, or FALSE.
  */
-gboolean purple_request_fields_all_valid(const PurpleRequestFields *fields);
+gboolean purple_request_page_all_valid(PurpleRequestPage *page);
 
 /**
- * purple_request_fields_get_field:
- * @fields: The fields list.
- * @id:     The ID of the field.
+ * purple_request_page_get_field:
+ * @page: The fields page.
+ * @id: The ID of the field.
  *
  * Return the field with the specified ID.
  *
  * Returns: (transfer none): The field, if found.
  */
-PurpleRequestField *purple_request_fields_get_field(
-		const PurpleRequestFields *fields, const char *id);
+PurpleRequestField *purple_request_page_get_field(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_string:
- * @fields: The fields list.
- * @id:     The ID of the field.
+ * purple_request_page_get_string:
+ * @page: The fields page.
+ * @id: The ID of the field.
  *
  * Returns the string value of a field with the specified ID.
  *
  * Returns: The string value, if found, or %NULL otherwise.
  */
-const char *purple_request_fields_get_string(const PurpleRequestFields *fields,
-										   const char *id);
+const char *purple_request_page_get_string(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_integer:
- * @fields: The fields list.
- * @id:     The ID of the field.
+ * purple_request_page_get_integer:
+ * @page: The fields page.
+ * @id: The ID of the field.
  *
  * Returns the integer value of a field with the specified ID.
  *
  * Returns: The integer value, if found, or 0 otherwise.
  */
-int purple_request_fields_get_integer(const PurpleRequestFields *fields,
-									const char *id);
+int purple_request_page_get_integer(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_bool:
- * @fields: The fields list.
- * @id:     The ID of the field.
+ * purple_request_page_get_bool:
+ * @page: The fields page.
+ * @id: The ID of the field.
  *
  * Returns the boolean value of a field with the specified ID.
  *
  * Returns: The boolean value, if found, or %FALSE otherwise.
  */
-gboolean purple_request_fields_get_bool(const PurpleRequestFields *fields,
-									  const char *id);
+gboolean purple_request_page_get_bool(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_choice:
- * @fields: The fields list.
+ * purple_request_page_get_choice:
+ * @page: The fields page.
  * @id:     The ID of the field.
  *
  * Returns the choice index of a field with the specified ID.
  *
  * Returns: The choice value, if found, or NULL otherwise.
  */
-gpointer
-purple_request_fields_get_choice(const PurpleRequestFields *fields,
-	const char *id);
+gpointer purple_request_page_get_choice(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_account:
- * @fields: The fields list.
+ * purple_request_page_get_account:
+ * @page: The fields page.
  * @id:     The ID of the field.
  *
  * Returns the account of a field with the specified ID.
  *
  * Returns: (transfer none): The account value, if found, or %NULL otherwise.
  */
-PurpleAccount *purple_request_fields_get_account(const PurpleRequestFields *fields,
-											 const char *id);
+PurpleAccount *purple_request_page_get_account(PurpleRequestPage *page, const char *id);
 
 /**
- * purple_request_fields_get_ui_data:
- * @fields: The fields list.
+ * purple_request_page_get_ui_data:
+ * @page: The fields page.
  *
  * Returns the UI data associated with this object.
  *
@@ -231,16 +215,16 @@ PurpleAccount *purple_request_fields_get
  *         convenience field provided to the UIs--it is not
  *         used by the libpurple core.
  */
-gpointer purple_request_fields_get_ui_data(const PurpleRequestFields *fields);
+gpointer purple_request_page_get_ui_data(PurpleRequestPage *page);
 
 /**
- * purple_request_fields_set_ui_data:
- * @fields: The fields list.
+ * purple_request_page_set_ui_data:
+ * @page: The fields page.
  * @ui_data: A pointer to associate with this object.
  *
  * Set the UI data associated with this object.
  */
-void purple_request_fields_set_ui_data(PurpleRequestFields *fields, gpointer ui_data);
+void purple_request_page_set_ui_data(PurpleRequestPage *page, gpointer ui_data);
 
 G_END_DECLS
 
diff --git a/libpurple/purplerequestpage.c b/libpurple/purplerequestpage.c
--- a/libpurple/purplerequestpage.c
+++ b/libpurple/purplerequestpage.c
@@ -25,8 +25,9 @@
 #include "purplerequestpage.h"
 #include "purpleprivate.h"
 
-struct _PurpleRequestFields
-{
+struct _PurpleRequestPage {
+	GObject parent;
+
 	GList *groups;
 
 	GHashTable *fields;
@@ -38,92 +39,134 @@ struct _PurpleRequestFields
 	void *ui_data;
 };
 
-PurpleRequestFields *
-purple_request_fields_new(void)
-{
-	PurpleRequestFields *fields;
+/******************************************************************************
+ * GListModel Implementation
+ *****************************************************************************/
+static GType
+purple_request_page_get_item_type(G_GNUC_UNUSED GListModel *model) {
+	return PURPLE_TYPE_REQUEST_GROUP;
+}
+
+static guint
+purple_request_page_get_n_items(GListModel *model) {
+	PurpleRequestPage *page = PURPLE_REQUEST_PAGE(model);
+
+	return g_list_length(page->groups);
+}
+
+static gpointer
+purple_request_page_get_item(GListModel *model, guint index) {
+	PurpleRequestPage *page = PURPLE_REQUEST_PAGE(model);
+
+	return g_list_nth_data(page->groups, index);
+}
+
+static void
+purple_request_page_list_model_init(GListModelInterface *iface) {
+	iface->get_item_type = purple_request_page_get_item_type;
+	iface->get_item = purple_request_page_get_item;
+	iface->get_n_items = purple_request_page_get_n_items;
+}
 
-	fields = g_new0(PurpleRequestFields, 1);
+/******************************************************************************
+ * GObject Implementation
+ *****************************************************************************/
+G_DEFINE_TYPE_WITH_CODE(PurpleRequestPage, purple_request_page, G_TYPE_OBJECT,
+                        G_IMPLEMENT_INTERFACE(G_TYPE_LIST_MODEL,
+                                              purple_request_page_list_model_init))
+
+static void
+purple_request_page_finalize(GObject *obj) {
+	PurpleRequestPage *page = PURPLE_REQUEST_PAGE(obj);
+
+	g_list_free_full(page->groups, g_object_unref);
+	g_list_free(page->required_fields);
+	g_list_free(page->validated_fields);
+	g_hash_table_destroy(page->fields);
+
+	G_OBJECT_CLASS(purple_request_page_parent_class)->finalize(obj);
+}
 
-	fields->fields = g_hash_table_new_full(g_str_hash, g_str_equal,
-										   g_free, NULL);
+static void
+purple_request_page_init(PurpleRequestPage *page) {
+	page->fields = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
+}
+
+static void
+purple_request_page_class_init(PurpleRequestPageClass *klass) {
+	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
 
-	return fields;
+	obj_class->finalize = purple_request_page_finalize;
+}
+
+/******************************************************************************
+ * Public API
+ *****************************************************************************/
+PurpleRequestPage *
+purple_request_page_new(void) {
+	return g_object_new(PURPLE_TYPE_REQUEST_PAGE, NULL);
 }
 
 void
-purple_request_fields_destroy(PurpleRequestFields *fields)
+_purple_request_page_set_field_required(PurpleRequestPage *page,
+                                        PurpleRequestField *field,
+                                        gboolean required)
 {
-	g_return_if_fail(fields != NULL);
-
-	g_list_free_full(fields->groups, g_object_unref);
-	g_list_free(fields->required_fields);
-	g_list_free(fields->validated_fields);
-	g_hash_table_destroy(fields->fields);
-	g_free(fields);
-}
-
-void
-_purple_request_field_list_set_field_required(PurpleRequestFields *fields,
-                                              PurpleRequestField *field,
-                                              gboolean required)
-{
-	g_return_if_fail(fields != NULL);
+	g_return_if_fail(PURPLE_IS_REQUEST_PAGE(page));
 
 	if(required) {
-		fields->required_fields = g_list_append(fields->required_fields, field);
+		page->required_fields = g_list_append(page->required_fields, field);
 	} else {
-		fields->required_fields = g_list_remove(fields->required_fields, field);
+		page->required_fields = g_list_remove(page->required_fields, field);
 	}
 }
 
 void
-_purple_request_field_list_set_field_validator(PurpleRequestFields *fields,
-                                               PurpleRequestField *field,
-                                               gboolean validator)
+_purple_request_page_set_field_validator(PurpleRequestPage *page,
+                                         PurpleRequestField *field,
+                                         gboolean validator)
 {
-	g_return_if_fail(fields != NULL);
+	g_return_if_fail(PURPLE_IS_REQUEST_PAGE(page));
 
-	fields->validated_fields = g_list_remove(fields->validated_fields, field);
+	page->validated_fields = g_list_remove(page->validated_fields, field);
 	if(validator) {
-		fields->validated_fields = g_list_append(fields->validated_fields,
-		                                         field);
+		page->validated_fields = g_list_append(page->validated_fields, field);
 	}
 }
 
 void
-_purple_request_field_list_add_field(PurpleRequestFields *fields,
-                                     PurpleRequestField *field)
+_purple_request_page_add_field(PurpleRequestPage *page,
+                               PurpleRequestField *field)
 {
-	g_return_if_fail(fields != NULL);
+	g_return_if_fail(PURPLE_IS_REQUEST_PAGE(page));
 
-	g_hash_table_insert(fields->fields,
+	g_hash_table_insert(page->fields,
 	                    g_strdup(purple_request_field_get_id(field)), field);
 
 	if(purple_request_field_is_required(field)) {
-		fields->required_fields = g_list_append(fields->required_fields,
-		                                        field);
+		page->required_fields = g_list_append(page->required_fields, field);
 	}
 
 	if(purple_request_field_is_validatable(field)) {
-		fields->validated_fields = g_list_append(fields->validated_fields,
-		                                         field);
+		page->validated_fields = g_list_append(page->validated_fields, field);
 	}
 }
 
 void
-purple_request_fields_add_group(PurpleRequestFields *fields,
-                                PurpleRequestGroup *group)
+purple_request_page_add_group(PurpleRequestPage *page,
+                              PurpleRequestGroup *group)
 {
+	guint position;
 	GList *l;
 	PurpleRequestField *field;
 
-	g_return_if_fail(fields != NULL);
+	g_return_if_fail(PURPLE_IS_REQUEST_PAGE(page));
 	g_return_if_fail(PURPLE_IS_REQUEST_GROUP(group));
 
-	fields->groups = g_list_append(fields->groups, group);
+	position = g_list_length(page->groups);
+	page->groups = g_list_append(page->groups, group);
 
-	_purple_request_group_set_field_list(group, fields);
+	_purple_request_group_set_page(group, page);
 
 	for (l = purple_request_group_get_fields(group);
 		 l != NULL;
@@ -131,78 +174,75 @@ purple_request_fields_add_group(PurpleRe
 
 		field = l->data;
 
-		g_hash_table_insert(fields->fields,
-			g_strdup(purple_request_field_get_id(field)), field);
+		g_hash_table_insert(page->fields,
+		                    g_strdup(purple_request_field_get_id(field)),
+		                    field);
 
 		if (purple_request_field_is_required(field)) {
-			fields->required_fields =
-				g_list_append(fields->required_fields, field);
+			page->required_fields = g_list_append(page->required_fields,
+			                                      field);
 		}
 
 		if (purple_request_field_is_validatable(field)) {
-			fields->validated_fields =
-				g_list_append(fields->validated_fields, field);
+			page->validated_fields = g_list_append(page->validated_fields,
+			                                       field);
 		}
 	}
+
+	g_list_model_items_changed(G_LIST_MODEL(page), position, 0, 1);
 }
 
 GList *
-purple_request_fields_get_groups(const PurpleRequestFields *fields)
-{
-	g_return_val_if_fail(fields != NULL, NULL);
+purple_request_page_get_groups(PurpleRequestPage *page) {
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 
-	return fields->groups;
+	return page->groups;
 }
 
 gboolean
-purple_request_fields_exists(const PurpleRequestFields *fields, const char *id)
-{
-	g_return_val_if_fail(fields != NULL, FALSE);
+purple_request_page_exists(PurpleRequestPage *page, const char *id) {
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), FALSE);
 	g_return_val_if_fail(id     != NULL, FALSE);
 
-	return (g_hash_table_lookup(fields->fields, id) != NULL);
+	return (g_hash_table_lookup(page->fields, id) != NULL);
 }
 
 const GList *
-purple_request_fields_get_required(const PurpleRequestFields *fields)
-{
-	g_return_val_if_fail(fields != NULL, NULL);
+purple_request_page_get_required(PurpleRequestPage *page) {
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 
-	return fields->required_fields;
+	return page->required_fields;
 }
 
 const GList *
-purple_request_fields_get_validatable(const PurpleRequestFields *fields)
-{
-	g_return_val_if_fail(fields != NULL, NULL);
+purple_request_page_get_validatable(PurpleRequestPage *page) {
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 
-	return fields->validated_fields;
+	return page->validated_fields;
 }
 
 gboolean
-purple_request_fields_is_field_required(const PurpleRequestFields *fields,
-									  const char *id)
+purple_request_page_is_field_required(PurpleRequestPage *page, const char *id)
 {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), FALSE);
 	g_return_val_if_fail(id     != NULL, FALSE);
 
-	if ((field = purple_request_fields_get_field(fields, id)) == NULL)
+	if((field = purple_request_page_get_field(page, id)) == NULL) {
 		return FALSE;
+	}
 
 	return purple_request_field_is_required(field);
 }
 
 gboolean
-purple_request_fields_all_required_filled(const PurpleRequestFields *fields)
-{
+purple_request_page_all_required_filled(PurpleRequestPage *page) {
 	GList *l;
 
-	g_return_val_if_fail(fields != NULL, FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), FALSE);
 
-	for (l = fields->required_fields; l != NULL; l = l->next)
-	{
+	for(l = page->required_fields; l != NULL; l = l->next) {
 		PurpleRequestField *field = PURPLE_REQUEST_FIELD(l->data);
 
 		if (!purple_request_field_is_filled(field))
@@ -213,14 +253,12 @@ purple_request_fields_all_required_fille
 }
 
 gboolean
-purple_request_fields_all_valid(const PurpleRequestFields *fields)
-{
+purple_request_page_all_valid(PurpleRequestPage *page) {
 	GList *l;
 
-	g_return_val_if_fail(fields != NULL, FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), FALSE);
 
-	for (l = fields->validated_fields; l != NULL; l = l->next)
-	{
+	for(l = page->validated_fields; l != NULL; l = l->next) {
 		PurpleRequestField *field = PURPLE_REQUEST_FIELD(l->data);
 
 		if (!purple_request_field_is_valid(field, NULL))
@@ -231,14 +269,13 @@ purple_request_fields_all_valid(const Pu
 }
 
 PurpleRequestField *
-purple_request_fields_get_field(const PurpleRequestFields *fields, const char *id)
-{
+purple_request_page_get_field(PurpleRequestPage *page, const char *id) {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, NULL);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 	g_return_val_if_fail(id     != NULL, NULL);
 
-	field = g_hash_table_lookup(fields->fields, id);
+	field = g_hash_table_lookup(page->fields, id);
 
 	g_return_val_if_fail(PURPLE_IS_REQUEST_FIELD(field), NULL);
 
@@ -246,88 +283,85 @@ purple_request_fields_get_field(const Pu
 }
 
 const char *
-purple_request_fields_get_string(const PurpleRequestFields *fields, const char *id)
-{
+purple_request_page_get_string(PurpleRequestPage *page, const char *id) {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, NULL);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 	g_return_val_if_fail(id     != NULL, NULL);
 
-	if ((field = purple_request_fields_get_field(fields, id)) == NULL)
+	if((field = purple_request_page_get_field(page, id)) == NULL) {
 		return NULL;
+	}
 
 	return purple_request_field_string_get_value(field);
 }
 
 int
-purple_request_fields_get_integer(const PurpleRequestFields *fields,
-								const char *id)
-{
+purple_request_page_get_integer(PurpleRequestPage *page, const char *id) {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, 0);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), 0);
 	g_return_val_if_fail(id     != NULL, 0);
 
-	if ((field = purple_request_fields_get_field(fields, id)) == NULL)
+	if((field = purple_request_page_get_field(page, id)) == NULL) {
 		return 0;
+	}
 
 	return purple_request_field_int_get_value(field);
 }
 
 gboolean
-purple_request_fields_get_bool(const PurpleRequestFields *fields, const char *id)
-{
+purple_request_page_get_bool(PurpleRequestPage *page, const char *id) {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, FALSE);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), FALSE);
 	g_return_val_if_fail(id     != NULL, FALSE);
 
-	if ((field = purple_request_fields_get_field(fields, id)) == NULL)
+	if((field = purple_request_page_get_field(page, id)) == NULL) {
 		return FALSE;
+	}
 
 	return purple_request_field_bool_get_value(field);
 }
 
 gpointer
-purple_request_fields_get_choice(const PurpleRequestFields *fields,
-	const char *id)
-{
+purple_request_page_get_choice(PurpleRequestPage *page, const char *id) {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, NULL);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 	g_return_val_if_fail(id != NULL, NULL);
 
-	if ((field = purple_request_fields_get_field(fields, id)) == NULL)
+	if((field = purple_request_page_get_field(page, id)) == NULL) {
 		return NULL;
+	}
 
 	return purple_request_field_choice_get_value(field);
 }
 
 PurpleAccount *
-purple_request_fields_get_account(const PurpleRequestFields *fields,
-								const char *id)
-{
+purple_request_page_get_account(PurpleRequestPage *page, const char *id) {
 	PurpleRequestField *field;
 
-	g_return_val_if_fail(fields != NULL, NULL);
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 	g_return_val_if_fail(id     != NULL, NULL);
 
-	if ((field = purple_request_fields_get_field(fields, id)) == NULL)
+	if((field = purple_request_page_get_field(page, id)) == NULL) {
 		return NULL;
+	}
 
 	return purple_request_field_account_get_value(field);
 }
 
-gpointer purple_request_fields_get_ui_data(const PurpleRequestFields *fields)
-{
-	g_return_val_if_fail(fields != NULL, NULL);
+gpointer
+purple_request_page_get_ui_data(PurpleRequestPage *page) {
+	g_return_val_if_fail(PURPLE_IS_REQUEST_PAGE(page), NULL);
 
-	return fields->ui_data;
+	return page->ui_data;
 }
 
-void purple_request_fields_set_ui_data(PurpleRequestFields *fields, gpointer ui_data)
-{
-	g_return_if_fail(fields != NULL);
+void
+purple_request_page_set_ui_data(PurpleRequestPage *page, gpointer ui_data) {
+	g_return_if_fail(PURPLE_IS_REQUEST_PAGE(page));
 
-	fields->ui_data = ui_data;
+	page->ui_data = ui_data;
 }
